<template>
    <div class="ht-modal" :class="{'ht-modal__open': open || closing}" >
        <span class="ht-modal__background" :class="{'ht-modal__background-open': open || closing}" v-on:click="close"></span>
        <!-- Modal content -->
        <div class="ht-modal__content" :class="{ 'ht-modal__content-closing': closing }">
            <div class="ht-modal__header">
                <span class="ht-modal__close" v-on:click="close">&times;</span>
                <slot name="header"></slot>
            </div>
            <div class="ht-modal__body">
                <slot name="body"></slot>
            </div>
            <div class="ht-modal__footer">
                <slot name="footer">
                </slot>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'ht-modal',
        emits: ['close'],
        props: {
            open: {
                default: false
            }
        },
        data() {
            return {
                closing: false
            }
        },
        methods: {
            close(event) {
                this.$emit('close', event);
            },
        },
        watch: {
            open(val) {
                if (!val) {
                    this.closing = true;
                    setTimeout(() => {
                        this.closing = false
                    }, 400);
                }
            }
        }

    };
</script>

<style scoped>

</style>
